diff --git a/doc/src/sgml/config.sgml b/doc/src/sgml/config.sgml
new file mode 100644
index f043433..65422d5
*** a/doc/src/sgml/config.sgml
--- b/doc/src/sgml/config.sgml
*************** COPY postgres_log FROM '/full/path/to/lo
*** 7793,7798 ****
--- 7793,7836 ----
      </variablelist>
     </sect1>
  
+    <sect1 id="runtime-config-encryption">
+     <title>Encryption Key Management</title>
+ 
+     <variablelist>
+      <varlistentry id="guc-cluster-passphrase-command" xreflabel="cluster_passphrase_command">
+       <term><varname>cluster_passphrase_command</varname> (<type>string</type>)
+       <indexterm>
+        <primary><varname>cluster_passphrase_command</varname> configuration parameter</primary>
+       </indexterm>
+       </term>
+       <listitem>
+        <para>
+         This option specifies an external command to be invoked when a
+         passphrase for key management system needs to be obtained.
+        </para>
+        <para>
+         The command must print the passphrase to the standard
+         output and have a zero exit code.  In the parameter value,
+         <literal>%p</literal> is replaced by a prompt string, and
+         <literal>%R</literal> represents the file descriptor for
+         reading/writing from the terminal; if specified at server start,
+         it is blank.  Since it can be blank, it is wise for it to be the
+         last command-line argument specified.  (Write <literal>%%</literal>
+         for a literal <literal>%</literal>.)  Note that the prompt string
+         will probably contain whitespace, so be sure to quote its use
+         adequately.  A single newline is stripped from the end of the
+         output if present.  The passphrase must be at least 64 bytes.
+        </para>
+        <para>
+         This parameter can only be set in the
+         <filename>postgresql.conf</filename> file or on the server
+         command line.
+        </para>
+       </listitem>
+      </varlistentry>
+     </variablelist>
+    </sect1>
+ 
     <sect1 id="runtime-config-client">
      <title>Client Connection Defaults</title>
  
*************** dynamic_library_path = 'C:\tools\postgre
*** 9636,9641 ****
--- 9674,9695 ----
         </para>
        </listitem>
       </varlistentry>
+ 
+       <varlistentry id="guc-key-management-enabled" xreflabel="key_management_enabled">
+       <term><varname>key_management_enabled</varname> (<type>boolean</type>)
+       <indexterm>
+        <primary>Key management configuration parameter parameter</primary>
+       </indexterm>
+       </term>
+       <listitem>
+        <para>
+         Reports whether encryption key management
+         is enabled for this cluster.  See <xref
+         linkend="app-initdb-cluster-passphrase-command"/> for more
+         information.
+        </para>
+       </listitem>
+      </varlistentry>
  
       <varlistentry id="guc-data-directory-mode" xreflabel="data_directory_mode">
        <term><varname>data_directory_mode</varname> (<type>integer</type>)
diff --git a/doc/src/sgml/filelist.sgml b/doc/src/sgml/filelist.sgml
new file mode 100644
index 38e8aa0..b96f4ac
*** a/doc/src/sgml/filelist.sgml
--- b/doc/src/sgml/filelist.sgml
***************
*** 49,54 ****
--- 49,55 ----
  <!ENTITY wal           SYSTEM "wal.sgml">
  <!ENTITY logical-replication    SYSTEM "logical-replication.sgml">
  <!ENTITY jit    SYSTEM "jit.sgml">
+ <!ENTITY database-encryption SYSTEM "database-encryption.sgml">
  
  <!-- programmer's guide -->
  <!ENTITY bgworker   SYSTEM "bgworker.sgml">
diff --git a/doc/src/sgml/func.sgml b/doc/src/sgml/func.sgml
new file mode 100644
index f7f401b..709f0dc
*** a/doc/src/sgml/func.sgml
--- b/doc/src/sgml/func.sgml
*************** SELECT m.* FROM pg_statistic_ext join pg
*** 26735,26738 ****
--- 26735,26837 ----
  
    </sect1>
  
+   <sect1 id="functions-encryption">
+    <title>Encryption Functions</title>
+ 
+    <sect2 id="functions-data-encryption">
+     <title>Data Encryption Function</title>
+     <para>
+      The functions shown in
+      <xref linkend="functions-encryption-table"/> are for encrypting
+      and decrypting data with the <literal>SQL key</literal> described in
+      <xref linkend="encryption-key-management"/>.
+     </para>
+ 
+     <table id="functions-encryption-table">
+      <title>Encryption <acronym>SQL</acronym> Functions</title>
+      <tgroup cols="3">
+       <thead>
+        <row>
+         <entry>Function</entry>
+         <entry>Return Type</entry>
+         <entry>Description</entry>
+        </row>
+       </thead>
+       <tbody>
+ 
+        <row>
+         <entry>
+          <indexterm>
+           <primary>pg_encrypt</primary>
+          </indexterm>
+          <literal><function>pg_encrypt(<parameter>data</parameter> <type>text</type>)</function></literal>
+         </entry>
+         <entry>
+          <type>bytea</type>
+         </entry>
+         <entry>
+          Encrypt the given data with the internal SQL key
+         </entry>
+        </row>
+ 
+        <row>
+         <entry>
+          <indexterm>
+           <primary>pg_unwrap</primary>
+          </indexterm>
+          <literal><function>pg_decrypt(<parameter>data</parameter> <type>bytea</type>)</function></literal>
+         </entry>
+         <entry>
+          <type>text</type>
+         </entry>
+         <entry>
+          Decrypt the given data with the internal SQL key
+         </entry>
+        </row>
+       </tbody>
+      </tgroup>
+     </table>
+    </sect2>
+ 
+    <sect2 id="functions-key-management">
+     <title>Key Management Functions</title>
+     <para>
+      The function shown in
+      <xref linkend="functions-key-management-table"/> are for encryption
+      key management described in <xref linkend="encryption-key-management"/>.
+     </para>
+ 
+     <table id="functions-key-management-table">
+      <title>Encryption Key Management <acronym>SQL</acronym> Functions</title>
+      <tgroup cols="3">
+       <thead>
+        <row>
+         <entry>Function</entry>
+         <entry>Return Type</entry>
+         <entry>Description</entry>
+        </row>
+       </thead>
+       <tbody>
+        <row>
+         <entry>
+          <indexterm>
+           <primary>pg_rotate_cluster_passphrase</primary>
+          </indexterm>
+          <literal><function>pg_rotate_cluster_passphrase()</function></literal>
+         </entry>
+         <entry>
+          <type>boolean</type>
+         </entry>
+         <entry>
+          Rotate the cluster passphrase. See
+          <xref linkend="key-management-rotation"/> for details.
+         </entry>
+        </row>
+ 
+       </tbody>
+      </tgroup>
+     </table>
+    </sect2>
+   </sect1>
+ 
  </chapter>
diff --git a/doc/src/sgml/installation.sgml b/doc/src/sgml/installation.sgml
new file mode 100644
index 0ac1cb9..ed58601
*** a/doc/src/sgml/installation.sgml
--- b/doc/src/sgml/installation.sgml
*************** build-postgresql:
*** 976,983 ****
         <listitem>
          <para>
           Build with support for <acronym>SSL</acronym> (encrypted)
!          connections. This requires the <productname>OpenSSL</productname>
!          package to be installed.  <filename>configure</filename> will check
           for the required header files and libraries to make sure that
           your <productname>OpenSSL</productname> installation is sufficient
           before proceeding.
--- 976,984 ----
         <listitem>
          <para>
           Build with support for <acronym>SSL</acronym> (encrypted)
!          connections and key management. This requires the
!          <productname>OpenSSL</productname> package to be installed.
!          <filename>configure</filename> will check
           for the required header files and libraries to make sure that
           your <productname>OpenSSL</productname> installation is sufficient
           before proceeding.
diff --git a/doc/src/sgml/postgres.sgml b/doc/src/sgml/postgres.sgml
new file mode 100644
index 730d5fd..0ea7da6
*** a/doc/src/sgml/postgres.sgml
--- b/doc/src/sgml/postgres.sgml
*************** break is not needed in a wider output re
*** 171,176 ****
--- 171,177 ----
    &wal;
    &logical-replication;
    &jit;
+   &database-encryption;
    &regress;
  
   </part>
diff --git a/doc/src/sgml/ref/initdb.sgml b/doc/src/sgml/ref/initdb.sgml
new file mode 100644
index 385ac25..1d0678a
*** a/doc/src/sgml/ref/initdb.sgml
--- b/doc/src/sgml/ref/initdb.sgml
*************** PostgreSQL documentation
*** 163,168 ****
--- 163,187 ----
        </listitem>
       </varlistentry>
  
+      <varlistentry id="app-initdb-cluster-passphrase-command" xreflabel="cluster passphrase command">
+       <term><option>--cluster-passphrase-command=<replaceable class="parameter">command</replaceable></option></term>
+       <listitem>
+        <para>
+         This option specifies an external command to be invoked when a passphrase
+         for key management system needs to be obtained.
+        </para>
+        <para>
+         The command must print the passphrase to the standard output and exit
+         with code 0.  In the parameter value, <literal>%p</literal> is
+         replaced by a prompt string.  (Write <literal>%%</literal> for a
+         literal <literal>%</literal>.)  Note that the prompt string will
+         probably contain whitespace, so be sure to quote adequately.  A single
+         newline is stripped from the end of the output if present.  The passphrase
+         must be at least 64 bytes.
+        </para>
+       </listitem>
+      </varlistentry>
+ 
       <varlistentry>
        <term><option>-D <replaceable class="parameter">directory</replaceable></option></term>
        <term><option>--pgdata=<replaceable class="parameter">directory</replaceable></option></term>
diff --git a/doc/src/sgml/ref/pg_ctl-ref.sgml b/doc/src/sgml/ref/pg_ctl-ref.sgml
new file mode 100644
index 3946fa5..3d34071
*** a/doc/src/sgml/ref/pg_ctl-ref.sgml
--- b/doc/src/sgml/ref/pg_ctl-ref.sgml
*************** PostgreSQL documentation
*** 38,43 ****
--- 38,44 ----
     <arg choice="opt"><option>-s</option></arg>
     <arg choice="opt"><option>-o</option> <replaceable>options</replaceable></arg>
     <arg choice="opt"><option>-p</option> <replaceable>path</replaceable></arg>
+    <arg choice="opt"><option>-R</option></arg>
     <arg choice="opt"><option>-c</option></arg>
    </cmdsynopsis>
  
*************** PostgreSQL documentation
*** 72,77 ****
--- 73,79 ----
     <arg choice="opt"><option>-t</option> <replaceable>seconds</replaceable></arg>
     <arg choice="opt"><option>-s</option></arg>
     <arg choice="opt"><option>-o</option> <replaceable>options</replaceable></arg>
+    <arg choice="opt"><option>-R</option></arg>
     <arg choice="opt"><option>-c</option></arg>
    </cmdsynopsis>
  
*************** PostgreSQL documentation
*** 372,377 ****
--- 374,390 ----
         </para>
        </listitem>
       </varlistentry>
+ 
+      <varlistentry>
+       <term><option>-R</option></term>
+       <term><option>--read-terminal</option></term>
+       <listitem>
+        <para>
+         Allow the server to read a password from the terminal.
+         This also disables dot-status progress reporting.
+        </para>
+       </listitem>
+      </varlistentry>
  
       <varlistentry>
        <term><option>-s</option></term>
diff --git a/doc/src/sgml/ref/pgupgrade.sgml b/doc/src/sgml/ref/pgupgrade.sgml
new file mode 100644
index b59c569..29b0015
*** a/doc/src/sgml/ref/pgupgrade.sgml
--- b/doc/src/sgml/ref/pgupgrade.sgml
*************** psql --username=postgres --file=script.s
*** 823,828 ****
--- 823,835 ----
     is down.
    </para>
  
+   <para>
+    During the upgrade <command>pg_upgrade</command> copies the all internal keys
+    to the new cluster. If you want to upgrade from the old cluster that enables
+    the key management to the new cluster that also enables, you must use the same
+    <varname>cluster_passphrase_command</varname> to both clusters. Otherwise
+    <command>pg_upgrade</command> fails due to mismatching the cluster passphrase.
+   </para>
   </refsect1>
  
   <refsect1>
diff --git a/doc/src/sgml/storage.sgml b/doc/src/sgml/storage.sgml
new file mode 100644
index 3234adb..05e9b26
*** a/doc/src/sgml/storage.sgml
--- b/doc/src/sgml/storage.sgml
*************** Item
*** 78,83 ****
--- 78,88 ----
  </row>
  
  <row>
+  <entry><filename>pg_cryptokeys</filename></entry>
+  <entry>Subdirectory containing cryptographic keys</entry>
+ </row>
+ 
+ <row>
   <entry><filename>pg_dynshmem</filename></entry>
   <entry>Subdirectory containing files used by the dynamic shared memory
    subsystem</entry>
diff --git a/src/backend/Makefile b/src/backend/Makefile
new file mode 100644
index 9706a95..4ace302
*** a/src/backend/Makefile
--- b/src/backend/Makefile
*************** SUBDIRS = access bootstrap catalog parse
*** 21,27 ****
  	main nodes optimizer partitioning port postmaster \
  	regex replication rewrite \
  	statistics storage tcop tsearch utils $(top_builddir)/src/timezone \
! 	jit
  
  include $(srcdir)/common.mk
  
--- 21,27 ----
  	main nodes optimizer partitioning port postmaster \
  	regex replication rewrite \
  	statistics storage tcop tsearch utils $(top_builddir)/src/timezone \
! 	jit crypto
  
  include $(srcdir)/common.mk
  
diff --git a/src/backend/access/transam/xlog.c b/src/backend/access/transam/xlog.c
new file mode 100644
index 52a67b1..955fd4a
*** a/src/backend/access/transam/xlog.c
--- b/src/backend/access/transam/xlog.c
***************
*** 44,54 ****
--- 44,56 ----
  #include "commands/tablespace.h"
  #include "common/controldata_utils.h"
  #include "executor/instrument.h"
+ #include "crypto/kmgr.h"
  #include "miscadmin.h"
  #include "pg_trace.h"
  #include "pgstat.h"
  #include "port/atomics.h"
  #include "postmaster/bgwriter.h"
+ #include "postmaster/postmaster.h"
  #include "postmaster/startup.h"
  #include "postmaster/walwriter.h"
  #include "replication/basebackup.h"
***************
*** 81,86 ****
--- 83,89 ----
  #include "utils/timestamp.h"
  
  extern uint32 bootstrap_data_checksum_version;
+ extern uint32 bootstrap_key_management_version;
  
  /* Unsupported old recovery command file names (relative to $PGDATA) */
  #define RECOVERY_COMMAND_FILE	"recovery.conf"
*************** InitControlFile(uint64 sysidentifier)
*** 4607,4612 ****
--- 4610,4616 ----
  	ControlFile->wal_log_hints = wal_log_hints;
  	ControlFile->track_commit_timestamp = track_commit_timestamp;
  	ControlFile->data_checksum_version = bootstrap_data_checksum_version;
+ 	ControlFile->key_management_version = bootstrap_key_management_version;
  }
  
  static void
*************** ReadControlFile(void)
*** 4894,4899 ****
--- 4898,4906 ----
  	/* Make the initdb settings visible as GUC variables, too */
  	SetConfigOption("data_checksums", DataChecksumsEnabled() ? "yes" : "no",
  					PGC_INTERNAL, PGC_S_OVERRIDE);
+ 
+ 	SetConfigOption("key_management", KeyManagementEnabled() ? "yes" : "no",
+ 					PGC_INTERNAL, PGC_S_OVERRIDE);
  }
  
  /*
*************** DataChecksumsEnabled(void)
*** 4937,4942 ****
--- 4944,4959 ----
  }
  
  /*
+  * Are key management enabled?
+  */
+ bool
+ KeyManagementEnabled(void)
+ {
+ 	Assert(ControlFile != NULL);
+ 	return (ControlFile->key_management_version > 0);
+ }
+ 
+ /*
   * Returns a fake LSN for unlogged relations.
   *
   * Each call generates an LSN that is greater than any previous value
*************** BootStrapXLOG(void)
*** 5343,5348 ****
--- 5360,5371 ----
  	/* some additional ControlFile fields are set in WriteControlFile() */
  	WriteControlFile();
  
+ 	/* Enable key manager if required */
+ 	if (ControlFile->key_management_version > 0)
+ 		BootStrapKmgr();
+ 	if (terminal_fd != -1)
+ 		close(terminal_fd);
+ 
  	/* Bootstrap the commit log, too */
  	BootStrapCLOG();
  	BootStrapCommitTs();
diff --git a/src/backend/bootstrap/bootstrap.c b/src/backend/bootstrap/bootstrap.c
new file mode 100644
index 76b2f50..bd7c04e
*** a/src/backend/bootstrap/bootstrap.c
--- b/src/backend/bootstrap/bootstrap.c
***************
*** 28,39 ****
--- 28,41 ----
  #include "catalog/pg_collation.h"
  #include "catalog/pg_type.h"
  #include "common/link-canary.h"
+ #include "crypto/kmgr.h"
  #include "libpq/pqsignal.h"
  #include "miscadmin.h"
  #include "nodes/makefuncs.h"
  #include "pg_getopt.h"
  #include "pgstat.h"
  #include "postmaster/bgwriter.h"
+ #include "postmaster/postmaster.h"
  #include "postmaster/startup.h"
  #include "postmaster/walwriter.h"
  #include "replication/walreceiver.h"
***************
*** 51,56 ****
--- 53,59 ----
  #include "utils/relmapper.h"
  
  uint32		bootstrap_data_checksum_version = 0;	/* No checksum */
+ uint32		bootstrap_key_management_version = 0;	/* disabled */
  
  
  static void CheckerModeMain(void);
*************** AuxiliaryProcessMain(int argc, char *arg
*** 224,230 ****
  	/* If no -x argument, we are a CheckerProcess */
  	MyAuxProcType = CheckerProcess;
  
! 	while ((flag = getopt(argc, argv, "B:c:d:D:Fkr:x:X:-:")) != -1)
  	{
  		switch (flag)
  		{
--- 227,233 ----
  	/* If no -x argument, we are a CheckerProcess */
  	MyAuxProcType = CheckerProcess;
  
! 	while ((flag = getopt(argc, argv, "B:c:d:D:eFkr:R:x:X:-:")) != -1)
  	{
  		switch (flag)
  		{
*************** AuxiliaryProcessMain(int argc, char *arg
*** 247,252 ****
--- 250,258 ----
  					pfree(debugstr);
  				}
  				break;
+ 			case 'e':
+ 				bootstrap_key_management_version = KMGR_VERSION;
+ 				break;
  			case 'F':
  				SetConfigOption("fsync", "false", PGC_POSTMASTER, PGC_S_ARGV);
  				break;
*************** AuxiliaryProcessMain(int argc, char *arg
*** 256,261 ****
--- 262,270 ----
  			case 'r':
  				strlcpy(OutputFileName, optarg, MAXPGPATH);
  				break;
+ 			case 'R':
+ 				terminal_fd = atoi(optarg);
+ 				break;
  			case 'x':
  				MyAuxProcType = atoi(optarg);
  				break;
diff --git a/src/backend/crypto/Makefile b/src/backend/crypto/Makefile
new file mode 100644
index ...c273620
*** a/src/backend/crypto/Makefile
--- b/src/backend/crypto/Makefile
***************
*** 0 ****
--- 1,18 ----
+ #-------------------------------------------------------------------------
+ #
+ # Makefile
+ #    Makefile for src/backend/crypto
+ #
+ # IDENTIFICATION
+ #    src/backend/crypto/Makefile
+ #
+ #-------------------------------------------------------------------------
+ 
+ subdir = src/backend/crypto
+ top_builddir = ../../..
+ include $(top_builddir)/src/Makefile.global
+ 
+ OBJS = \
+ 	kmgr.o
+ 
+ include $(top_srcdir)/src/backend/common.mk
